#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"

// LED_/p}N
#define ON 0x00
#define OFF 0xFF

// LED_p^[pϐ
char State;

// 荞ݏ
void Timer0IntHandler(void)
{
	// ^C}[Zbg
	TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
	
	// rbg]
	State = ~State;
	// LEDON/OFFɂ
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
}

// LED̓_łXCb`ő삷
void main(void)
{
	// ҂ԗp
	volatile unsigned long Loop;
	// wpϐ
	int Cycle;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_6MHZ);
    
    // gp|[g̑I@̓|[gDI
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    // SWpɃ|[gBgp
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    // ^C}[0gp邱Ƃ錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);
    
    // PD0o̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);
    // PB0,PB1̓^Cvɐݒ
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_1);
    
    //@^C}[032bitJE^Ŏgp
    TimerConfigure(TIMER0_BASE, TIMER_CFG_32_BIT_PER);
    // ^C}[0̊荞݂Ԋuݒ
    TimerLoadSet(TIMER0_BASE, TIMER_A, SysCtlClockGet());
    // 荞ݎɌĂяoi֐jw
    TimerIntRegister(TIMER0_BASE, TIMER_A, Timer0IntHandler);
    // 荞݂
    IntEnable(INT_TIMER0A);
    // ^CAEgŊ荞݂
    TimerIntEnable(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
    // ^C}[荞݂
    TimerEnable(TIMER0_BASE, TIMER_A);
    
    State = OFF;
    // LEDOFFɂ
    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
    // 1bi1[Hz]jZbg
    Cycle = 1;
    
    while(1)
    {
    	// ǂSWꂽ
    	if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_0) == 0)
    	{
    		// 荞ݎ𑁂
    		Cycle++;
    		// ^C}[0̊荞݂Ԋuݒ
    		TimerLoadSet(TIMER0_BASE, TIMER_A, SysCtlClockGet()/Cycle);
    		// `^O΍p҂
    		for(Loop = 0; Loop < 200000; Loop++);
    	}
    	else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_1) == 0)
    	{
    		// 荞ݎx
    		Cycle --;
    		// 1bȉɂȂ
    		if (Cycle <= 0)
    		{
    			Cycle = 1;
    		}
    		// ^C}[0̊荞݂Ԋuݒ
    		TimerLoadSet(TIMER0_BASE, TIMER_A, SysCtlClockGet()/Cycle);
    		// `^O΍p҂
    		for(Loop = 0; Loop < 200000; Loop++);
    	}
    	
    }
}
